# ../addons/eventscripts/superdice/superdice.py
##########################
#~~~~~~~Super~Dice~~~~~~~#
#~~~~~~~~~By~MiB~~~~~~~~~#
##########################
import es,random,cmdlib,popuplib,gamethread,weaponlib,usermsg,effectlib
import psyco
psyco.full()

info = es.AddonInfo()
info["name"] = "Super Dice"
info["basename"] = "superdice"
info["version"] = "0.5"
info["authors"] = "MiB"
info["url"] = "http://www.warcraft-source.com"
info["description"] = "The best dice mod!"

blocks = {}
players = {}
ccommands = ["rtd","!rtd","superdice","!superdice","rollthedice","!rollthedice"]
hcommands = ["rtdhelp","!rtdhelp","superdicehelp","!superdicehelp"]
playervars = ["inf","lust","roll","berserker","feeble","highjump","longjump","sunglasses","deadman","heavy","beacon","lasers"]
blist = ["c4","nvg","suit","knife","elite"]
variables = ["superdice_menusound","superdice_rolltime","superdice_rollsound","superdice_rollchanceshout","superdice_infmod","superdice_heavymax","superdice_heavymin","superdice_rollchance","superdice_shout","superdice_healthmod","superdice_superhealthmod","superdice_cursemod","superdice_tmp","superdice_tmp1","superdice_tmp2","superdice_timemod","superdice_lustmod","superdice_diceymin","superdice_diceymax","superdice_armormod","superdice_berserkerspeed","superdice_berserkerclip","superdice_berserkerhealth","superdice_illusionalpha","superdice_feeblemod","superdice_badeyesmin","superdice_badeyesmax","superdice_badeyesdur","superdice_weightsmod","superdice_superdiceblock","superdice_superdicehelpblock","superdice_aeromod","superdice_acromod","superdice_tmp3"]
for var in variables: es.ServerVar(var).set(0)
maindir = "addons/eventscripts/superdice"
configdir = "cfg/eventscripts/superdice"
events = "%s/superdice.res"%maindir
config = "../%s/superdice.cfg"%configdir

def load():
        es.doblock("corelib/noisy_on")
        es.load("superdice/superdiceblocks")
        cmdlib.registerServerCommand("superdice_addblock",AddBlock,"Adds a block to Super Dice's blocks list. | superdice_addblock <blockname> <rollname> <rolldesc>",skipcheck=True)
	cmdlib.registerServerCommand("superdice_removeblock",RemoveBlock,"Removes a block from Super Dice's blocks list. | superdice_removeblock <block name>",skipcheck=True)
	cmdlib.registerServerCommand("superdice_clearblocks",ClearBlocks,"Clears the blocks from Super Dice's blocks list. | superdice_clearblocks",skipcheck=True)
	cmdlib.registerServerCommand("superdice_reloadblocks",ReloadBlocks,"Reloads Super Dice's superdiceblocks script. | superdice_reloadblocks",skipcheck=True)
	cmdlib.registerServerCommand("superdice_reloadconfig",ReloadConfig,"Reloads Super Dice's config. | superdice_reloadconfig",skipcheck=True)
	cmdlib.registerServerCommand("superdice_createhelp",CreateHelp,"Creates the help popup. | superdice_createhelp",skipcheck=True)
	cmdlib.registerServerCommand("superdice_playerdata",PlayerData,"Lets you set/get/check Super Dice's playerdata. | superdice_playerdata <set/get/check> <userid> <dataname> <setting/return var/return var>",skipcheck=True)
	cmdlib.registerServerCommand("superdice_randomblind",RandomBlind,"Lets start a random delayed blinding on a player. | superdice_randomblind <userid> <min time> <max time> <blind time>",skipcheck=True)
	cmdlib.registerServerCommand("superdice_respawn",Respawn,"Respawns a player. | superdice_respawn <userid>",skipcheck=True)
	cmdlib.registerServerCommand("superdice_tunnel",Tunnel,"Puts tunnel aura on a player. | superdice_tunnel <userid>",skipcheck=True)
	cmdlib.registerServerCommand("superdice_drug",Drug,"Puts drugging on a player. | superdice_drug <userid>",skipcheck=True)
	es.addons.registerTickListener(tickcallback)
        es.mexec(config)
        es.loadevents("declare",events)
	es.loadevents(events)
        es.addons.registerSayFilter(chatcommands)
        roundchange(0)
	es.ServerVar("superdice_version").set("v0.5")
	es.ServerVar("superdice_version").makepublic()
	downloads()

def unload():
        es.doblock("corelib/noisy_off")
        es.unload("superdice/superdiceblocks")
	cmdlib.unregisterServerCommand("superdice_addblock")
	cmdlib.unregisterServerCommand("superdice_removeblock")
	cmdlib.unregisterServerCommand("superdice_clearblocks")
	cmdlib.unregisterServerCommand("superdice_reloadblocks")
	cmdlib.unregisterServerCommand("superdice_reloadconfig")
	cmdlib.unregisterServerCommand("superdice_createhelp")
	cmdlib.unregisterServerCommand("superdice_playerdata")
	cmdlib.unregisterServerCommand("superdice_randomblind")
	cmdlib.unregisterServerCommand("superdice_respawn")
	cmdlib.unregisterServerCommand("superdice_tunnel")
	cmdlib.unregisterServerCommand("superdice_drug")
	es.addons.unregisterTickListener(tickcallback)
	es.addons.unregisterSayFilter(chatcommands)

def es_map_start(ev):
	es.loadevents(events)
	roundchange(0)
        players = {}
        stoprepeat()
        downloads()

def tickcallback():
        for userid in es.getUseridList():
                if es.exists("userid",userid):
                        userid = str(userid)
                        if userid in players:
                                if int(players[userid]["beacon"]) == 1 and players[userid]["beacon"].isdigit():
                                        __beacon(userid,"sprites/tp_beam001.vmt")

def __beacon(userid,effect):
        if es.getplayerprop(userid,"CCSPlayer.baseclass.pl.deadflag") == 0:
                if es.getplayerteam(userid) == 3:
                        r = 0
                        b = 255
                else:
                        r = 255
                        b = 0
                x,y,z = es.getplayerlocation(userid)
                effectlib.drawCircle((x,y,z + 30),radius=100,steps=12,halo=effect,model=effect,seconds=0.1,width=20,endwidth=20,red=r,green=50,blue=b)
                effectlib.drawLine((x,y,z),(x,y,z + 99999),halo=effect,model=effect,seconds=0.1,width=20,endwidth=20,red=r,green=50,blue=b)

def downloads():
        es.stringtable("downloadables","sound/%s"%es.ServerVar("superdice_rollsound"))
        es.stringtable("downloadables","sound/%s"%es.ServerVar("superdice_menusound"))

def popup_create():
        global superdice_help
        superdice_help = popuplib.easymenu("superdice_help",None,superdice_help)
        superdice_help.settitle("SuperDice Help Menu")
        for block in blocks: superdice_help.addoption(block,"%s - %s"%(blocks[block]["name"],blocks[block]["desc"]))

def check_player(userid):
        userid = str(userid)
        if userid not in players:
                players[userid] = {}
                for var in playervars: players[userid][var] = 0

def superdice_help(userid,choice,popupname):
        es.playsound(userid,es.ServerVar("superdice_menusound"),1.0)
        es.tell(userid,"#multi","\x05%s: %s"%(blocks[choice]["name"],blocks[choice]["desc"]))
        superdice_help.send(userid)

def stoprepeat():
        gamethread.cancelDelayed("blind")
	gamethread.cancelDelayed("tunnel")
	gamethread.cancelDelayed("drug")
	gamethread.cancelDelayed("roundstart")

def roundchange(change):
        global roundend
        roundend = change

def AddBlock(args):
	if len(args) == 3:
		if args[0] not in blocks:
			blocks[args[0]] = {}
			blocks[args[0]]["name"] = args[1]
                        blocks[args[0]]["desc"] = args[2]
                        es.dbgmsg(0,"<addblock> Block was added. <%s - %s - %s>"%(args[0],args[1],args[2]))
		else: es.dbgmsg(0,"<addblock> You supplied a name thats already added. <%s>"%block)
	else: es.dbgmsg(0,"<addblock> You supplied more or less than three arguments.")

def RemoveBlock(args):
	if len(args) == 1:
		if args[0] in blocks:
			del blocks[args[0]]
			es.dbgmsg(0,"<removeblock> Block was removed. <%s>"%args[0])
		else: es.dbgmsg(0,"<removeblock> You supplied a name thats not added. <%s>"%block)
	else: es.dbgmsg(0,"<removeblock> You supplied more or less than one argument.")

def ClearBlocks(args):
	if len(blocks) > 0:
		blocks = {}
	else: es.dbgmsg(0,"<clearblocks> The blocks list is empty.")

def ReloadBlocks(args):
	es.reload("superdice/superdiceblocks")
	es.dbgmsg(0,"<reloadblocks> Blocks reloaded.")

def ReloadConfig(args):
        es.mexec(config)
	es.dbgmsg(0,"<reloadconfig> Config reloaded.")

def CreateHelp(args):
        popup_create()
        es.dbgmsg(0,"<createhelp> Help Menu created.")

def PlayerData(args):
        if len(args) == 4:
                if es.exists("userid",args[1]):
                        userid = str(args[1])
                        if userid not in players: check_player(userid)
                        if args[0] == "set":
                                players[userid][args[2]] = args[3]
                        elif args[0] == "get":
                                if args[2] in players[userid]: es.ServerVar(args[3]).set(players[userid][args[2]])
                                else: es.dbgmsg(0,"<playerdata> Sorry, but it seems that the dataname you supplied does not exist, so can not get your requested data.")
                        elif args[0] == "check":
                                if args[2] in players[userid]: es.ServerVar(args[3]).set(1)
                                else: es.ServerVar(args[3]).set(0)
                        else: es.dbgmsg(0,"<playerdata> Argument one is not set,get, or check, please check your coding.")
                else: es.dbgmsg(0,"<playerdata> The userid you supplied is not on the server.")
        else: es.dbgmsg(0,"<playerdata> You supplied more or less than four arguments.")

def RandomBlind(args):
        if len(args) == 4:
                if es.exists("userid",args[0]):
                        if es.getplayerprop(args[0],"CCSPlayer.baseclass.pl.deadflag") == 0:
                                __randomblind(args[0],int(args[1]),int(args[2]),float(args[3]))
                        else: es.dbgmsg(0,"<randomblind> The userid you supplied is dead.")
                else: es.dbgmsg(0,"<randomblind> The userid you supplied is not on the server.")
        else: es.dbgmsg(0,"<randomblind> You supplied more or less than 4 arguments.")

def __randomblind(userid,rbmin,rbmax,rbtime):
        if es.exists("userid",userid):
                if es.getplayerprop(userid,"CCSPlayer.baseclass.pl.deadflag") == 0:
                        usermsg.fade(userid,2,(rbtime * float(100)),(rbtime * float(100)),0,0,0,255)
                        delay = random.randint(rbmin,rbmax)
                        gamethread.delayedname(delay,"blind",__randomblind,(userid,rbmin,rbmax,rbtime))

def Respawn(args):
        if len(args) == 1:
                if es.exists("userid",args[0]):
                        if es.getplayerprop(args[0],"CCSPlayer.baseclass.pl.deadflag") == 1:
                                __respawn(args[0])
                        else: es.dbgmsg(0,"<respawn> The userid you supplied is alive.")
                else: es.dbgmsg(0,"<respawn> The userid you supplied is not on the server.")
        else: es.dbgmsg(0,"<respawn> You supplied more or less than 1 argument.")

def __respawn(userid):
        if es.exists("userid",userid):
                if es.getplayerprop(userid,"CCSPlayer.baseclass.pl.deadflag") == 1:
                        es.setplayerprop(userid,"CCSPlayer.m_iPlayerState",0)
                        es.setplayerprop(userid,"CCSPlayer.baseclass.m_lifeState",512)
                        es.server.queuecmd("es_xspawnplayer %s"%userid)

def Tunnel(args):
        if len(args) == 1:
                if es.exists("userid",args[0]):
                        if es.getplayerprop(args[0],"CCSPlayer.baseclass.pl.deadflag") == 0:
                                __tunnel(args[0])
                        else: es.dbgmsg(0,"<tunnel> The userid you supplied is dead.")
                else: es.dbgmsg(0,"<tunnel> The userid you supplied is not on the server.")
        else: es.dbgmsg(0,"<tunnel> You supplied more or less than 1 argument.")

def __tunnel(userid):
        if es.exists("userid",userid):
                if es.getplayerprop(userid,"CCSPlayer.baseclass.pl.deadflag") == 0:
                        es.setplayerprop(userid,"CCSPlayer.baseclass.m_iFOV",150)
                        gamethread.delayedname(0.000001,"tunnel",__tunnel,userid)

def Drug(args):
        if len(args) == 1:
                if es.exists("userid",args[0]):
                        if es.getplayerprop(args[0],"CCSPlayer.baseclass.pl.deadflag") == 0:
                                __drug(args[0])
                        else: es.dbgmsg(0,"<drug> The userid you supplied is dead.")
                else: es.dbgmsg(0,"<drug> The userid you supplied is not on the server.")
        else: es.dbgmsg(0,"<drug> You supplied more or less than 1 argument.")

def __drug(userid):
        if es.exists("userid",userid):
                if es.getplayerprop(userid,"CCSPlayer.baseclass.pl.deadflag") == 0:
                        es.cexec(userid,"r_screenoverlay effects/tp_eyefx/tp_eyefx")
                        gamethread.delayedname(0.000001,"drug",__drug,userid)

def chatcommands(userid,text,teamonly):
        if int(userid) < 2: return (userid,text,teamonly)
        else: userid = str(userid)
        text2 = text.strip('"')
        text2 = text2.lower()
	if text2 in ccommands:
                check_player(userid)
		if es.getplayerprop(userid,"CCSPlayer.baseclass.pl.deadflag") == 0 and roundend == 1 and int(players[userid]["roll"]) == 0:
                        rollchance = random.randint(1,100)
                        if int(es.ServerVar("superdice_rollchance")) < rollchance:
                                roll = random.choice(blocks.keys())
                                if roll in blocks:
                                        rollname = blocks[roll]["name"]
                                        es.event("initialize","superdice_roll")
                                        es.event("setint","superdice_roll","userid",userid)
                                        es.event("setstring","superdice_roll","block",roll)
                                        es.event("setstring","superdice_roll","roll",rollname)
                                        es.event("fire","superdice_roll")
                                        players[userid]["roll"] = 1
                                        if int(es.ServerVar("superdice_shout")) == 1: es.msg("#multi","\x05%s rolled %s."%(es.getplayername(userid),rollname))
                                        else: es.tell(userid,"#multi","\x05You rolled %s."%rollname)
                                else: es.tell(userid,"#multi","\x05Sorry, but theres been a error please roll again.")
                        else:
                                if int(es.ServerVar("superdice_rollchanceshout")) == 1: es.msg("#multi","\x05%s failed to roll anything."%es.getplayername(userid))
                                else: es.tell(userid,"#multi","\x05Sorry, you failed to roll anything.")
                                players[userid]["roll"] = 1
		else: es.tell(userid,"#multi","\x05You cannot roll right now.")
		if int(es.ServerVar("superdice_superdiceblock")) == 1: return (False,False,False)
        elif text2 in hcommands:
                superdice_help.send(userid)
                if int(es.ServerVar("superdice_superdicehelpblock")) == 1: return (False,False,False)
        return (int(userid),text,teamonly)

def round_end(ev):
	roundchange(0)
	stoprepeat()

def round_start(ev):
	gamethread.delayedname(float(es.ServerVar("superdice_rolltime")),"roundstart",roundchange,1)

def player_spawn(ev):
        check_player(ev["userid"])
        if int(players[ev["userid"]]["roll"]) == 1: players[ev["userid"]]["roll"] = 0

def superdice_roll(ev):
        es.doblock("superdice/superdiceblocks/%s"%ev["block"])
        es.playsound(ev["userid"],es.ServerVar("superdice_rollsound"),1.0)

def item_pickup(ev):
        if ev["userid"] not in players: return
        if int(players[ev["userid"]]["berserker"]) == 1 and players[ev["userid"]]["berserker"].isdigit() and ev["item"] not in blist:
                weapon = weaponlib.getWeapon(ev["item"])
                if weapon is None: return
                for index in weapon.indexlist:
                        if es.getindexprop(index,"CBaseEntity.m_hOwnerEntity") == es.getplayerhandle(ev["userid"]):
                                es.remove(index)
                                break

def bullet_impact(ev):
        if ev["userid"] not in players or ev["es_userweapon"] == "weapon_knife": return
        if int(players[ev["userid"]]["lasers"]) == 1 and players[ev["userid"]]["lasers"].isdigit():
                if es.getplayerteam(ev["userid"]) == 3:
                        r = 0
                        b = 255
                else:
                        r = 255
                        b = 0
                x,y,z = es.getplayerlocation(ev["userid"])
                effectlib.drawLine((x,y,z + 20),(ev["x"],ev["y"],ev["z"]),halo="sprites/tp_beam001.vmt",model="sprites/tp_beam001.vmt",seconds=0.5,width=30,endwidth=30,red=r,green=50,blue=b)
                effectlib.drawLine((x,y,z + 20),(ev["x"],ev["y"],ev["z"]),halo="sprites/tp_beam001.vmt",model="sprites/tp_beam001.vmt",seconds=0.5,width=30,endwidth=30,red=r,green=50,blue=b)
